diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/nav-menu.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/nav-menu.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/nav-menu.php	2012-11-05 19:01:52.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/nav-menu.php	2013-07-27 01:50:59.000000000 -0500
***************
*** 14,20 ****
  	 *
  	 * @param string $output Passed by reference.
  	 */
! 	function start_lvl(&$output) {}
  
  	/**
  	 * @see Walker_Nav_Menu::end_lvl()
--- 14,20 ----
  	 *
  	 * @param string $output Passed by reference.
  	 */
! 	function start_lvl( &$output, $depth = 0, $args = array() ) {}
  
  	/**
  	 * @see Walker_Nav_Menu::end_lvl()
***************
*** 22,29 ****
  	 *
  	 * @param string $output Passed by reference.
  	 */
! 	function end_lvl(&$output) {
! 	}
  
  	/**
  	 * @see Walker::start_el()
--- 22,28 ----
  	 *
  	 * @param string $output Passed by reference.
  	 */
! 	function end_lvl( &$output, $depth = 0, $args = array() ) {}
  
  	/**
  	 * @see Walker::start_el()
***************
*** 34,40 ****
  	 * @param int $depth Depth of menu item. Used for padding.
  	 * @param object $args
  	 */
! 	function start_el(&$output, $item, $depth, $args) {
  		global $_wp_nav_menu_max_depth;
  		$_wp_nav_menu_max_depth = $depth > $_wp_nav_menu_max_depth ? $depth : $_wp_nav_menu_max_depth;
  
--- 33,39 ----
  	 * @param int $depth Depth of menu item. Used for padding.
  	 * @param object $args
  	 */
! 	function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {
  		global $_wp_nav_menu_max_depth;
  		$_wp_nav_menu_max_depth = $depth > $_wp_nav_menu_max_depth ? $depth : $_wp_nav_menu_max_depth;
  
***************
*** 79,91 ****
  			$title = sprintf( __('%s (Pending)'), $item->title );
  		}
  
! 		$title = empty( $item->label ) ? $title : $item->label;
  
  		?>
  		<li id="menu-item-<?php echo $item_id; ?>" class="<?php echo implode(' ', $classes ); ?>">
  			<dl class="menu-item-bar">
  				<dt class="menu-item-handle">
! 					<span class="item-title"><?php echo esc_html( $title ); ?></span>
  					<span class="item-controls">
  						<span class="item-type"><?php echo esc_html( $item->type_label ); ?></span>
  						<span class="item-order hide-if-js">
--- 78,94 ----
  			$title = sprintf( __('%s (Pending)'), $item->title );
  		}
  
! 		$title = ( ! isset( $item->label ) || '' == $item->label ) ? $title : $item->label;
! 
! 		$submenu_text = '';
! 		if ( 0 == $depth )
! 			$submenu_text = 'style="display: none;"';
  
  		?>
  		<li id="menu-item-<?php echo $item_id; ?>" class="<?php echo implode(' ', $classes ); ?>">
  			<dl class="menu-item-bar">
  				<dt class="menu-item-handle">
! 					<span class="item-title"><span class="menu-item-title"><?php echo esc_html( $title ); ?></span> <span class="is-submenu" <?php echo $submenu_text; ?>><?php _e( 'sub item' ); ?></span></span>
  					<span class="item-controls">
  						<span class="item-type"><?php echo esc_html( $item->type_label ); ?></span>
  						<span class="item-order hide-if-js">
***************
*** 169,174 ****
--- 172,188 ----
  					</label>
  				</p>
  
+ 				<p class="field-move hide-if-no-js description description-wide">
+ 					<label>
+ 						<span><?php _e( 'Move' ); ?></span>
+ 						<a href="#" class="menus-move-up"><?php _e( 'Up one' ); ?></a>
+ 						<a href="#" class="menus-move-down"><?php _e( 'Down one' ); ?></a>
+ 						<a href="#" class="menus-move-left"></a>
+ 						<a href="#" class="menus-move-right"></a>
+ 						<a href="#" class="menus-move-top"><?php _e( 'To the top' ); ?></a>
+ 					</label>
+ 				</p>
+ 
  				<div class="menu-item-actions description-wide submitbox">
  					<?php if( 'custom' != $item->type && $original_title !== false ) : ?>
  						<p class="link-to-original">
***************
*** 182,191 ****
  								'action' => 'delete-menu-item',
  								'menu-item' => $item_id,
  							),
! 							remove_query_arg($removed_args, admin_url( 'nav-menus.php' ) )
  						),
  						'delete-menu_item_' . $item_id
! 					); ?>"><?php _e('Remove'); ?></a> <span class="meta-sep"> | </span> <a class="item-cancel submitcancel" id="cancel-<?php echo $item_id; ?>" href="<?php	echo esc_url( add_query_arg( array('edit-menu-item' => $item_id, 'cancel' => time()), remove_query_arg( $removed_args, admin_url( 'nav-menus.php' ) ) ) );
  						?>#menu-item-settings-<?php echo $item_id; ?>"><?php _e('Cancel'); ?></a>
  				</div>
  
--- 196,205 ----
  								'action' => 'delete-menu-item',
  								'menu-item' => $item_id,
  							),
! 							admin_url( 'nav-menus.php' )
  						),
  						'delete-menu_item_' . $item_id
! 					); ?>"><?php _e( 'Remove' ); ?></a> <span class="meta-sep hide-if-no-js"> | </span> <a class="item-cancel submitcancel hide-if-no-js" id="cancel-<?php echo $item_id; ?>" href="<?php echo esc_url( add_query_arg( array( 'edit-menu-item' => $item_id, 'cancel' => time() ), admin_url( 'nav-menus.php' ) ) );
  						?>#menu-item-settings-<?php echo $item_id; ?>"><?php _e('Cancel'); ?></a>
  				</div>
  
***************
*** 216,227 ****
  		}
  	}
  
! 	function start_lvl( &$output, $depth ) {
  		$indent = str_repeat( "\t", $depth );
  		$output .= "\n$indent<ul class='children'>\n";
  	}
  
! 	function end_lvl( &$output, $depth ) {
  		$indent = str_repeat( "\t", $depth );
  		$output .= "\n$indent</ul>";
  	}
--- 230,241 ----
  		}
  	}
  
! 	function start_lvl( &$output, $depth = 0, $args = array() ) {
  		$indent = str_repeat( "\t", $depth );
  		$output .= "\n$indent<ul class='children'>\n";
  	}
  
! 	function end_lvl( &$output, $depth = 0, $args = array() ) {
  		$indent = str_repeat( "\t", $depth );
  		$output .= "\n$indent</ul>";
  	}
***************
*** 235,241 ****
  	 * @param int $depth Depth of menu item. Used for padding.
  	 * @param object $args
  	 */
! 	function start_el(&$output, $item, $depth, $args) {
  		global $_nav_menu_placeholder;
  
  		$_nav_menu_placeholder = ( 0 > $_nav_menu_placeholder ) ? intval($_nav_menu_placeholder) - 1 : -1;
--- 249,255 ----
  	 * @param int $depth Depth of menu item. Used for padding.
  	 * @param object $args
  	 */
! 	function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {
  		global $_nav_menu_placeholder;
  
  		$_nav_menu_placeholder = ( 0 > $_nav_menu_placeholder ) ? intval($_nav_menu_placeholder) - 1 : -1;
***************
*** 250,255 ****
--- 264,271 ----
  		if ( property_exists( $item, 'front_or_home' ) && $item->front_or_home ) {
  			$title = sprintf( _x( 'Home: %s', 'nav menu front page title' ), $item->post_title );
  			$output .= ' add-to-top';
+ 		} elseif ( property_exists( $item, 'label' ) ) {
+ 			$title = $item->label;
  		}
  		$output .= '" name="menu-item[' . $possible_object_id . '][menu-item-object-id]" value="'. esc_attr( $item->object_id ) .'" /> ';
  		$output .= isset( $title ) ? esc_html( $title ) : esc_html( $item->title );
***************
*** 382,395 ****
   **/
  function wp_nav_menu_setup() {
  	// Register meta boxes
- 	if ( wp_get_nav_menus() )
- 		add_meta_box( 'nav-menu-theme-locations', __( 'Theme Locations' ), 'wp_nav_menu_locations_meta_box' , 'nav-menus', 'side', 'default' );
- 	add_meta_box( 'add-custom-links', __('Custom Links'), 'wp_nav_menu_item_link_meta_box', 'nav-menus', 'side', 'default' );
  	wp_nav_menu_post_type_meta_boxes();
  	wp_nav_menu_taxonomy_meta_boxes();
  
  	// Register advanced menu items (columns)
! 	add_filter( 'manage_nav-menus_columns', 'wp_nav_menu_manage_columns');
  
  	// If first time editing, disable advanced items by default.
  	if( false === get_user_option( 'managenav-menuscolumnshidden' ) ) {
--- 398,409 ----
   **/
  function wp_nav_menu_setup() {
  	// Register meta boxes
  	wp_nav_menu_post_type_meta_boxes();
+ 	add_meta_box( 'add-custom-links', __( 'Links' ), 'wp_nav_menu_item_link_meta_box', 'nav-menus', 'side', 'default' );
  	wp_nav_menu_taxonomy_meta_boxes();
  
  	// Register advanced menu items (columns)
! 	add_filter( 'manage_nav-menus_columns', 'wp_nav_menu_manage_columns' );
  
  	// If first time editing, disable advanced items by default.
  	if( false === get_user_option( 'managenav-menuscolumnshidden' ) ) {
***************
*** 411,417 ****
  	if ( get_user_option( 'metaboxhidden_nav-menus' ) !== false || ! is_array($wp_meta_boxes) )
  		return;
  
! 	$initial_meta_boxes = array( 'nav-menu-theme-locations', 'add-custom-links', 'add-page', 'add-category' );
  	$hidden_meta_boxes = array();
  
  	foreach ( array_keys($wp_meta_boxes['nav-menus']) as $context ) {
--- 425,431 ----
  	if ( get_user_option( 'metaboxhidden_nav-menus' ) !== false || ! is_array($wp_meta_boxes) )
  		return;
  
! 	$initial_meta_boxes = array( 'nav-menu-theme-locations', 'add-page', 'add-custom-links', 'add-category' );
  	$hidden_meta_boxes = array();
  
  	foreach ( array_keys($wp_meta_boxes['nav-menus']) as $context ) {
***************
*** 445,451 ****
  		$post_type = apply_filters( 'nav_menu_meta_box_object', $post_type );
  		if ( $post_type ) {
  			$id = $post_type->name;
! 			add_meta_box( "add-{$id}", $post_type->labels->name, 'wp_nav_menu_item_post_type_meta_box', 'nav-menus', 'side', 'default', $post_type );
  		}
  	}
  }
--- 459,467 ----
  		$post_type = apply_filters( 'nav_menu_meta_box_object', $post_type );
  		if ( $post_type ) {
  			$id = $post_type->name;
! 			// give pages a higher priority
! 			$priority = ( 'page' == $post_type->name ? 'core' : 'default' );
! 			add_meta_box( "add-{$id}", $post_type->labels->name, 'wp_nav_menu_item_post_type_meta_box', 'nav-menus', 'side', $priority, $post_type );
  		}
  	}
  }
***************
*** 489,495 ****
  	$menu_locations = get_nav_menu_locations();
  	$num_locations = count( array_keys($locations) );
  
! 	echo '<p class="howto">' . sprintf( _n('Your theme supports %s menu. Select which menu you would like to use.', 'Your theme supports %s menus. Select which menu appears in each location.', $num_locations ), number_format_i18n($num_locations) ) . '</p>';
  
  	foreach ( $locations as $location => $description ) {
  		?>
--- 505,511 ----
  	$menu_locations = get_nav_menu_locations();
  	$num_locations = count( array_keys($locations) );
  
! 	echo '<p class="howto">' . _n( 'Select a menu to use within your theme.', 'Select the menus you will use in your theme.', $num_locations ) . '</p>';
  
  	foreach ( $locations as $location => $description ) {
  		?>
***************
*** 500,509 ****
  					<option value="0"></option>
  					<?php foreach ( $menus as $menu ) : ?>
  					<option<?php selected( isset( $menu_locations[ $location ] ) && $menu_locations[ $location ] == $menu->term_id ); ?>
! 						value="<?php echo $menu->term_id; ?>"><?php
! 						$truncated_name = wp_html_excerpt( $menu->name, 40 );
! 						echo $truncated_name == $menu->name ? $menu->name : trim( $truncated_name ) . '&hellip;';
! 					?></option>
  					<?php endforeach; ?>
  				</select>
  			</label>
--- 516,522 ----
  					<option value="0"></option>
  					<?php foreach ( $menus as $menu ) : ?>
  					<option<?php selected( isset( $menu_locations[ $location ] ) && $menu_locations[ $location ] == $menu->term_id ); ?>
! 						value="<?php echo $menu->term_id; ?>"><?php echo wp_html_excerpt( $menu->name, 40, '&hellip;' ); ?></option>
  					<?php endforeach; ?>
  				</select>
  			</label>
***************
*** 512,567 ****
  	}
  	?>
  	<p class="button-controls">
! 		<?php submit_button( __( 'Save' ), 'primary right', 'nav-menu-locations', false, disabled( $nav_menu_selected_id, 0, false ) ); ?>
  		<span class="spinner"></span>
  	</p>
  	<?php
  }
  
  /**
   * Displays a metabox for the custom links menu item.
   *
   * @since 3.0.0
   */
  function wp_nav_menu_item_link_meta_box() {
  	global $_nav_menu_placeholder, $nav_menu_selected_id;
- 	$_nav_menu_placeholder = 0 > $_nav_menu_placeholder ? $_nav_menu_placeholder - 1 : -1;
  
! 	$current_tab = 'create';
! 	if ( isset( $_REQUEST['customlink-tab'] ) && in_array( $_REQUEST['customlink-tab'], array('create', 'all') ) ) {
! 		$current_tab = $_REQUEST['customlink-tab'];
! 	}
! 
! 	$removed_args = array(
! 		'action',
! 		'customlink-tab',
! 		'edit-menu-item',
! 		'menu-item',
! 		'page-tab',
! 		'_wpnonce',
! 	);
  
  	?>
  	<div class="customlinkdiv" id="customlinkdiv">
  
! 			<input type="hidden" value="custom" name="menu-item[<?php echo $_nav_menu_placeholder; ?>][menu-item-type]" />
! 			<p id="menu-item-url-wrap">
! 				<label class="howto" for="custom-menu-item-url">
! 					<span><?php _e('URL'); ?></span>
! 					<input id="custom-menu-item-url" name="menu-item[<?php echo $_nav_menu_placeholder; ?>][menu-item-url]" type="text" class="code menu-item-textbox" value="http://" />
! 				</label>
! 			</p>
! 
! 			<p id="menu-item-name-wrap">
! 				<label class="howto" for="custom-menu-item-name">
! 					<span><?php _e('Label'); ?></span>
! 					<input id="custom-menu-item-name" name="menu-item[<?php echo $_nav_menu_placeholder; ?>][menu-item-title]" type="text" class="regular-text menu-item-textbox input-with-default-title" title="<?php esc_attr_e('Menu Item'); ?>" />
! 				</label>
! 			</p>
  
  		<p class="button-controls">
  			<span class="add-to-menu">
! 				<input type="submit"<?php disabled( $nav_menu_selected_id, 0 ); ?> class="button-secondary submit-add-to-menu right" value="<?php esc_attr_e('Add to Menu'); ?>" name="add-custom-menu-item" id="submit-customlinkdiv" />
  				<span class="spinner"></span>
  			</span>
  		</p>
--- 525,586 ----
  	}
  	?>
  	<p class="button-controls">
! 		<?php submit_button( __( 'Save' ), 'primary right', 'nav-menu-locations', false, wp_nav_menu_disabled_check( $nav_menu_selected_id ) ); ?>
  		<span class="spinner"></span>
  	</p>
  	<?php
  }
  
  /**
+  * Check whether to disable the Menu Locations meta box submit button
+  *
+  * @since 3.6.0
+  *
+  * @uses global $one_theme_location_no_menus to determine if no menus exist
+  * @uses disabled() to output the disabled attribute in $other_attributes param in submit_button()
+  *
+  * @param int|string $nav_menu_selected_id (id, name or slug) of the currently-selected menu
+  * @return string Disabled attribute if at least one menu exists, false if not
+ */
+ function wp_nav_menu_disabled_check( $nav_menu_selected_id ) {
+ 	global $one_theme_location_no_menus;
+ 
+ 	if ( $one_theme_location_no_menus )
+ 		return false;
+ 
+ 	return disabled( $nav_menu_selected_id, 0 );
+ }
+ 
+ /**
   * Displays a metabox for the custom links menu item.
   *
   * @since 3.0.0
   */
  function wp_nav_menu_item_link_meta_box() {
  	global $_nav_menu_placeholder, $nav_menu_selected_id;
  
! 	$_nav_menu_placeholder = 0 > $_nav_menu_placeholder ? $_nav_menu_placeholder - 1 : -1;
  
  	?>
  	<div class="customlinkdiv" id="customlinkdiv">
+ 		<input type="hidden" value="custom" name="menu-item[<?php echo $_nav_menu_placeholder; ?>][menu-item-type]" />
+ 		<p id="menu-item-url-wrap">
+ 			<label class="howto" for="custom-menu-item-url">
+ 				<span><?php _e('URL'); ?></span>
+ 				<input id="custom-menu-item-url" name="menu-item[<?php echo $_nav_menu_placeholder; ?>][menu-item-url]" type="text" class="code menu-item-textbox" value="http://" />
+ 			</label>
+ 		</p>
  
! 		<p id="menu-item-name-wrap">
! 			<label class="howto" for="custom-menu-item-name">
! 				<span><?php _e( 'Link Text' ); ?></span>
! 				<input id="custom-menu-item-name" name="menu-item[<?php echo $_nav_menu_placeholder; ?>][menu-item-title]" type="text" class="regular-text menu-item-textbox input-with-default-title" title="<?php esc_attr_e('Menu Item'); ?>" />
! 			</label>
! 		</p>
  
  		<p class="button-controls">
  			<span class="add-to-menu">
! 				<input type="submit"<?php wp_nav_menu_disabled_check( $nav_menu_selected_id ); ?> class="button-secondary submit-add-to-menu right" value="<?php esc_attr_e('Add to Menu'); ?>" name="add-custom-menu-item" id="submit-customlinkdiv" />
  				<span class="spinner"></span>
  			</span>
  		</p>
***************
*** 661,670 ****
  	?>
  	<div id="posttype-<?php echo $post_type_name; ?>" class="posttypediv">
  		<ul id="posttype-<?php echo $post_type_name; ?>-tabs" class="posttype-tabs add-menu-item-tabs">
! 			<li <?php echo ( 'most-recent' == $current_tab ? ' class="tabs"' : '' ); ?>><a class="nav-tab-link" href="<?php if ( $nav_menu_selected_id ) echo esc_url(add_query_arg($post_type_name . '-tab', 'most-recent', remove_query_arg($removed_args))); ?>#tabs-panel-posttype-<?php echo $post_type_name; ?>-most-recent"><?php _e('Most Recent'); ?></a></li>
! 			<li <?php echo ( 'all' == $current_tab ? ' class="tabs"' : '' ); ?>><a class="nav-tab-link" href="<?php if ( $nav_menu_selected_id ) echo esc_url(add_query_arg($post_type_name . '-tab', 'all', remove_query_arg($removed_args))); ?>#<?php echo $post_type_name; ?>-all"><?php _e('View All'); ?></a></li>
! 			<li <?php echo ( 'search' == $current_tab ? ' class="tabs"' : '' ); ?>><a class="nav-tab-link" href="<?php if ( $nav_menu_selected_id ) echo esc_url(add_query_arg($post_type_name . '-tab', 'search', remove_query_arg($removed_args))); ?>#tabs-panel-posttype-<?php echo $post_type_name; ?>-search"><?php _e('Search'); ?></a></li>
! 		</ul>
  
  		<div id="tabs-panel-posttype-<?php echo $post_type_name; ?>-most-recent" class="tabs-panel <?php
  			echo ( 'most-recent' == $current_tab ? 'tabs-panel-active' : 'tabs-panel-inactive' );
--- 680,701 ----
  	?>
  	<div id="posttype-<?php echo $post_type_name; ?>" class="posttypediv">
  		<ul id="posttype-<?php echo $post_type_name; ?>-tabs" class="posttype-tabs add-menu-item-tabs">
! 			<li <?php echo ( 'most-recent' == $current_tab ? ' class="tabs"' : '' ); ?>>
! 				<a class="nav-tab-link" data-type="tabs-panel-posttype-<?php echo esc_attr( $post_type_name ); ?>-most-recent" href="<?php if ( $nav_menu_selected_id ) echo esc_url(add_query_arg($post_type_name . '-tab', 'most-recent', remove_query_arg($removed_args))); ?>#tabs-panel-posttype-<?php echo $post_type_name; ?>-most-recent">
! 					<?php _e( 'Most Recent' ); ?>
! 				</a>
! 			</li>
! 			<li <?php echo ( 'all' == $current_tab ? ' class="tabs"' : '' ); ?>>
! 				<a class="nav-tab-link" data-type="<?php echo esc_attr( $post_type_name ); ?>-all" href="<?php if ( $nav_menu_selected_id ) echo esc_url(add_query_arg($post_type_name . '-tab', 'all', remove_query_arg($removed_args))); ?>#<?php echo $post_type_name; ?>-all">
! 					<?php _e( 'View All' ); ?>
! 				</a>
! 			</li>
! 			<li <?php echo ( 'search' == $current_tab ? ' class="tabs"' : '' ); ?>>
! 				<a class="nav-tab-link" data-type="tabs-panel-posttype-<?php echo esc_attr( $post_type_name ); ?>-search" href="<?php if ( $nav_menu_selected_id ) echo esc_url(add_query_arg($post_type_name . '-tab', 'search', remove_query_arg($removed_args))); ?>#tabs-panel-posttype-<?php echo $post_type_name; ?>-search">
! 					<?php _e( 'Search'); ?>
! 				</a>
! 			</li>
! 		</ul><!-- .posttype-tabs -->
  
  		<div id="tabs-panel-posttype-<?php echo $post_type_name; ?>-most-recent" class="tabs-panel <?php
  			echo ( 'most-recent' == $current_tab ? 'tabs-panel-active' : 'tabs-panel-inactive' );
***************
*** 768,785 ****
  		<p class="button-controls">
  			<span class="list-controls">
  				<a href="<?php
! 					echo esc_url(add_query_arg(
  						array(
  							$post_type_name . '-tab' => 'all',
  							'selectall' => 1,
  						),
! 						remove_query_arg($removed_args)
  					));
  				?>#posttype-<?php echo $post_type_name; ?>" class="select-all"><?php _e('Select All'); ?></a>
  			</span>
  
  			<span class="add-to-menu">
! 				<input type="submit"<?php disabled( $nav_menu_selected_id, 0 ); ?> class="button-secondary submit-add-to-menu right" value="<?php esc_attr_e('Add to Menu'); ?>" name="add-post-type-menu-item" id="submit-posttype-<?php echo $post_type_name; ?>" />
  				<span class="spinner"></span>
  			</span>
  		</p>
--- 799,816 ----
  		<p class="button-controls">
  			<span class="list-controls">
  				<a href="<?php
! 					echo esc_url( add_query_arg(
  						array(
  							$post_type_name . '-tab' => 'all',
  							'selectall' => 1,
  						),
! 						remove_query_arg( $removed_args )
  					));
  				?>#posttype-<?php echo $post_type_name; ?>" class="select-all"><?php _e('Select All'); ?></a>
  			</span>
  
  			<span class="add-to-menu">
! 				<input type="submit"<?php wp_nav_menu_disabled_check( $nav_menu_selected_id ); ?> class="button-secondary submit-add-to-menu right" value="<?php esc_attr_e( __( 'Add to Menu' ) ); ?>" name="add-post-type-menu-item" id="<?php esc_attr_e( 'submit-posttype-' . $post_type_name ); ?>" />
  				<span class="spinner"></span>
  			</span>
  		</p>
***************
*** 871,880 ****
  	?>
  	<div id="taxonomy-<?php echo $taxonomy_name; ?>" class="taxonomydiv">
  		<ul id="taxonomy-<?php echo $taxonomy_name; ?>-tabs" class="taxonomy-tabs add-menu-item-tabs">
! 			<li <?php echo ( 'most-used' == $current_tab ? ' class="tabs"' : '' ); ?>><a class="nav-tab-link" href="<?php if ( $nav_menu_selected_id ) echo esc_url(add_query_arg($taxonomy_name . '-tab', 'most-used', remove_query_arg($removed_args))); ?>#tabs-panel-<?php echo $taxonomy_name; ?>-pop"><?php _e('Most Used'); ?></a></li>
! 			<li <?php echo ( 'all' == $current_tab ? ' class="tabs"' : '' ); ?>><a class="nav-tab-link" href="<?php if ( $nav_menu_selected_id ) echo esc_url(add_query_arg($taxonomy_name . '-tab', 'all', remove_query_arg($removed_args))); ?>#tabs-panel-<?php echo $taxonomy_name; ?>-all"><?php _e('View All'); ?></a></li>
! 			<li <?php echo ( 'search' == $current_tab ? ' class="tabs"' : '' ); ?>><a class="nav-tab-link" href="<?php if ( $nav_menu_selected_id ) echo esc_url(add_query_arg($taxonomy_name . '-tab', 'search', remove_query_arg($removed_args))); ?>#tabs-panel-search-taxonomy-<?php echo $taxonomy_name; ?>"><?php _e('Search'); ?></a></li>
! 		</ul>
  
  		<div id="tabs-panel-<?php echo $taxonomy_name; ?>-pop" class="tabs-panel <?php
  			echo ( 'most-used' == $current_tab ? 'tabs-panel-active' : 'tabs-panel-inactive' );
--- 902,923 ----
  	?>
  	<div id="taxonomy-<?php echo $taxonomy_name; ?>" class="taxonomydiv">
  		<ul id="taxonomy-<?php echo $taxonomy_name; ?>-tabs" class="taxonomy-tabs add-menu-item-tabs">
! 			<li <?php echo ( 'most-used' == $current_tab ? ' class="tabs"' : '' ); ?>>
! 				<a class="nav-tab-link" data-type="tabs-panel-<?php echo esc_attr( $taxonomy_name ); ?>-pop" href="<?php if ( $nav_menu_selected_id ) echo esc_url(add_query_arg($taxonomy_name . '-tab', 'most-used', remove_query_arg($removed_args))); ?>#tabs-panel-<?php echo $taxonomy_name; ?>-pop">
! 					<?php _e( 'Most Used' ); ?>
! 				</a>
! 			</li>
! 			<li <?php echo ( 'all' == $current_tab ? ' class="tabs"' : '' ); ?>>
! 				<a class="nav-tab-link" data-type="tabs-panel-<?php echo esc_attr( $taxonomy_name ); ?>-all" href="<?php if ( $nav_menu_selected_id ) echo esc_url(add_query_arg($taxonomy_name . '-tab', 'all', remove_query_arg($removed_args))); ?>#tabs-panel-<?php echo $taxonomy_name; ?>-all">
! 					<?php _e( 'View All' ); ?>
! 				</a>
! 			</li>
! 			<li <?php echo ( 'search' == $current_tab ? ' class="tabs"' : '' ); ?>>
! 				<a class="nav-tab-link" data-type="tabs-panel-search-taxonomy-<?php echo esc_attr( $taxonomy_name ); ?>" href="<?php if ( $nav_menu_selected_id ) echo esc_url(add_query_arg($taxonomy_name . '-tab', 'search', remove_query_arg($removed_args))); ?>#tabs-panel-search-taxonomy-<?php echo $taxonomy_name; ?>">
! 					<?php _e( 'Search' ); ?>
! 				</a>
! 			</li>
! 		</ul><!-- .taxonomy-tabs -->
  
  		<div id="tabs-panel-<?php echo $taxonomy_name; ?>-pop" class="tabs-panel <?php
  			echo ( 'most-used' == $current_tab ? 'tabs-panel-active' : 'tabs-panel-inactive' );
***************
*** 955,961 ****
  			</span>
  
  			<span class="add-to-menu">
! 				<input type="submit"<?php disabled( $nav_menu_selected_id, 0 ); ?> class="button-secondary submit-add-to-menu right" value="<?php esc_attr_e('Add to Menu'); ?>" name="add-taxonomy-menu-item" id="submit-taxonomy-<?php echo $taxonomy_name; ?>" />
  				<span class="spinner"></span>
  			</span>
  		</p>
--- 998,1004 ----
  			</span>
  
  			<span class="add-to-menu">
! 				<input type="submit"<?php wp_nav_menu_disabled_check( $nav_menu_selected_id ); ?> class="button-secondary submit-add-to-menu right" value="<?php esc_attr_e( __( 'Add to Menu' ) ); ?>" name="add-taxonomy-menu-item" id="<?php esc_attr_e( 'submit-taxonomy-' . $taxonomy_name ); ?>" />
  				<span class="spinner"></span>
  			</span>
  		</p>
***************
*** 1086,1092 ****
  		$menu_items = wp_get_nav_menu_items( $menu->term_id, array('post_status' => 'any') );
  		$result = '<div id="menu-instructions" class="post-body-plain';
  		$result .= ( ! empty($menu_items) ) ? ' menu-instructions-inactive">' : '">';
! 		$result .= '<p>' . __('Select menu items (pages, categories, links) from the boxes at left to begin building your custom menu.') . '</p>';
  		$result .= '</div>';
  
  		if( empty($menu_items) )
--- 1129,1135 ----
  		$menu_items = wp_get_nav_menu_items( $menu->term_id, array('post_status' => 'any') );
  		$result = '<div id="menu-instructions" class="post-body-plain';
  		$result .= ( ! empty($menu_items) ) ? ' menu-instructions-inactive">' : '">';
! 		$result .= '<p>' . __( 'Add menu items from the column on the left.' ) . '</p>';
  		$result .= '</div>';
  
  		if( empty($menu_items) )
***************
*** 1158,1162 ****
  	foreach( (array) $menu_items_to_delete as $menu_item_id )
  		wp_delete_post( $menu_item_id, true );
  }
- 
  add_action('admin_head-nav-menus.php', '_wp_delete_orphaned_draft_menu_items');
--- 1201,1288 ----
  	foreach( (array) $menu_items_to_delete as $menu_item_id )
  		wp_delete_post( $menu_item_id, true );
  }
  add_action('admin_head-nav-menus.php', '_wp_delete_orphaned_draft_menu_items');
+ 
+ /**
+  * Saves nav menu items
+  *
+  * @since 3.6.0
+  *
+  * @uses wp_get_nav_menu_items() to retrieve the nav menu's menu items
+  * @uses wp_defer_term_counter() to enable then disable term counting
+  *
+  * @param int|string $nav_menu_selected_id (id, slug, or name ) of the currently-selected menu
+  * @param string $nav_menu_selected_title Title of the currently-selected menu
+  * @return array $messages The menu updated message
+  */
+ function wp_nav_menu_update_menu_items ( $nav_menu_selected_id, $nav_menu_selected_title ) {
+ 	$unsorted_menu_items = wp_get_nav_menu_items( $nav_menu_selected_id, array( 'orderby' => 'ID', 'output' => ARRAY_A, 'output_key' => 'ID', 'post_status' => 'draft,publish' ) );
+ 
+ 	$menu_items = array();
+ 	// Index menu items by db ID
+ 	foreach ( $unsorted_menu_items as $_item )
+ 		$menu_items[$_item->db_id] = $_item;
+ 
+ 	$post_fields = array(
+ 		'menu-item-db-id', 'menu-item-object-id', 'menu-item-object',
+ 		'menu-item-parent-id', 'menu-item-position', 'menu-item-type',
+ 		'menu-item-title', 'menu-item-url', 'menu-item-description',
+ 		'menu-item-attr-title', 'menu-item-target', 'menu-item-classes', 'menu-item-xfn'
+ 	);
+ 
+ 	wp_defer_term_counting( true );
+ 	// Loop through all the menu items' POST variables
+ 	if ( ! empty( $_POST['menu-item-db-id'] ) ) {
+ 		foreach( (array) $_POST['menu-item-db-id'] as $_key => $k ) {
+ 
+ 			// Menu item title can't be blank
+ 			if ( ! isset( $_POST['menu-item-title'][ $_key ] ) || '' == $_POST['menu-item-title'][ $_key ] )
+ 				continue;
+ 
+ 			$args = array();
+ 			foreach ( $post_fields as $field )
+ 				$args[$field] = isset( $_POST[$field][$_key] ) ? $_POST[$field][$_key] : '';
+ 
+ 			$menu_item_db_id = wp_update_nav_menu_item( $nav_menu_selected_id, ( $_POST['menu-item-db-id'][$_key] != $_key ? 0 : $_key ), $args );
+ 
+ 			if ( is_wp_error( $menu_item_db_id ) )
+ 				$messages[] = '<div id="message" class="error"><p>' . $menu_item_db_id->get_error_message() . '</p></div>';
+ 			elseif ( isset( $menu_items[$menu_item_db_id] ) )
+ 				unset( $menu_items[$menu_item_db_id] );
+ 		}
+ 	}
+ 
+ 	// Remove menu items from the menu that weren't in $_POST
+ 	if ( ! empty( $menu_items ) ) {
+ 		foreach ( array_keys( $menu_items ) as $menu_item_id ) {
+ 			if ( is_nav_menu_item( $menu_item_id ) ) {
+ 				wp_delete_post( $menu_item_id );
+ 			}
+ 		}
+ 	}
+ 
+ 	// Store 'auto-add' pages.
+ 	$auto_add = ! empty( $_POST['auto-add-pages'] );
+ 	$nav_menu_option = (array) get_option( 'nav_menu_options' );
+ 	if ( ! isset( $nav_menu_option['auto_add'] ) )
+ 		$nav_menu_option['auto_add'] = array();
+ 	if ( $auto_add ) {
+ 		if ( ! in_array( $nav_menu_selected_id, $nav_menu_option['auto_add'] ) )
+ 			$nav_menu_option['auto_add'][] = $nav_menu_selected_id;
+ 	} else {
+ 		if ( false !== ( $key = array_search( $nav_menu_selected_id, $nav_menu_option['auto_add'] ) ) )
+ 			unset( $nav_menu_option['auto_add'][$key] );
+ 	}
+ 	// Remove nonexistent/deleted menus
+ 	$nav_menu_option['auto_add'] = array_intersect( $nav_menu_option['auto_add'], wp_get_nav_menus( array( 'fields' => 'ids' ) ) );
+ 	update_option( 'nav_menu_options', $nav_menu_option );
+ 
+ 	wp_defer_term_counting( false );
+ 
+ 	do_action( 'wp_update_nav_menu', $nav_menu_selected_id );
+ 
+ 	$messages[] = '<div id="message" class="updated"><p>' . sprintf( __( '<strong>%1$s</strong> has been updated.' ), $nav_menu_selected_title ) . '</p></div>';
+ 	unset( $menu_items, $unsorted_menu_items );
+ 
+ 	return $messages;
+ }
